<?php
/**
* joomla_lms.quiz.html.php
* (c) JoomaLMS eLearning Software http://www.joomlalms.com/
**/

// no direct access
defined( '_JLMS_EXEC' ) or die( 'Restricted access' );

class JLMS_quiz_html {
	static function ShowCertificates( $option, $id, &$rows ) {
		global $Itemid;
		$JLMS_CONFIG = JLMSFactory::getConfig();
		echo new \LMS\Widgets\ContentHeader(array('title' => _JLMS_QUIZ_CERTIFICATES_TITLE, 'icon' => 'quizzes'));
		JLMS_quiz_admin_html_class::ShowQuizzesTabs($option, $id, 4);
		$contentToolbar = new \LMS\Widgets\ContentToolbar();
		$contentToolbar->addNewButton(
			array(
				'href' => JRoute::_("index.php?option=$option&Itemid=$Itemid&id=$id&task=quizzes&page=add_crtf"),
				'tip' => _JLMS_QUIZ_NEW_CRTF_BTN
			)
		);
		$dropDownActions = $contentToolbar->addDropDownButton(array('title' => 'Actions', 'icon' => 'wrench'));
		$dropDownActions->addEditItem(array('href' => "javascript:submitbutton('edit_crtf');", 'title' => _JLMS_QUIZ_EDIT_CRTF_BTN));
		$dropDownActions->addDeleteItem(array('href' => "javascript:submitbutton('del_crtf');", 'title' => _JLMS_QUIZ_DEL_CRTF_BTN));
		$contentToolbar->addPreviewButton(array('href' => "javascript:submit_preview();", 'title' => _JLMS_QUIZ_PREVIEW_CRTF_BTN));
		echo $contentToolbar->render();
		?>
<script language="javascript" type="text/javascript">
<!--
function submitbutton(pressbutton) {
	var form = document.adminForm;
	if ( ((pressbutton == 'edit_crtf') || (pressbutton == 'del_crtf') ) && (form.boxchecked.value == "0")) {
		alert('<?php echo _JLMS_ALERT_SELECT_ITEM;?>');
	} else {
		form.page.value = pressbutton;
		form.submit();
	}
}
function submit_preview() {
	var crtf_id = 0;
	var form = document.adminForm;
	if (form.boxchecked.value == "0") {
		alert('<?php echo _JLMS_ALERT_SELECT_ITEM;?>');
	} else {
		var selItem = document.adminForm['cid[]'];
		if (selItem) {
			if (selItem.length) { var i;
				for (i = 0; i<selItem.length; i++) {
					if (selItem[i].checked) {
						if (selItem[i].value > 0) { crtf_id = selItem[i].value; break; }
					}
				}
			} else if (selItem.checked) { crtf_id = selItem.value; }
		}
		if (crtf_id != '0' && crtf_id != '0') {
			window.open('<?php echo $JLMS_CONFIG->get('live_site')."/index.php?tmpl=component&option=com_joomla_lms&Itemid=$Itemid&no_html=1&task=quizzes&id=$id&page=preview_crtf&crtf_id='+crtf_id+'";?>');
		}
	}
}
//-->
</script>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&Itemid=$Itemid");?>" method="post" name="adminForm">
		<table width="100%" cellpadding="0" cellspacing="0" border="0" class="<?php echo JLMSCSS::_('jlmslist');?>">
			<thead>
			<tr>
				<th width="20" class="<?php echo JLMSCSS::_('sectiontableheader');?>" align="center">#</th>
				<th width="20" class="<?php echo JLMSCSS::_('sectiontableheader');?>" align="center"><input type="checkbox" name="toggle" value="" onclick="<?php /*smt*/ echo JLMS_getCheckAll(count($rows));?>" /></th>
				<th class="<?php echo JLMSCSS::_('sectiontableheader');?>"><?php echo _JLMS_QUIZ_TBL_CRTF_NAME;?></th>
			</tr>
			</thead>
		<tbody>
		<?php
		$k = 1;
		for ($i=0, $n=count($rows); $i < $n; $i++) {
			$row = $rows[$i];
			#$link 	= sefRelToAbs("index.php?option=".$option."&amp;Itemid=".$Itemid."&amp;task=quizzes&amp;id=$id&amp;page=quizzes&amp;cat_id=". $row->c_id);
			$checked = mosHTML::idBox( $i, $row->id);?>
			<tr class="<?php echo JLMSCSS::_('sectiontableentry'.$k); ?>">
				<td align="center"><?php echo $i + 1; ?></td>
				<td align="center"><?php echo $checked; ?></td>
				<td align="left">
					<?php echo $row->crtf_name ? $row->crtf_name : $row->crtf_text;?>
				</td>
			</tr>
			<?php
			$k = 3 - $k;
		}?>
		</tbody>
		</table>
		<input type="hidden" name="option" value="<?php echo $option;?>" />
		<input type="hidden" name="page" value="" />
		<input type="hidden" name="task" value="quizzes" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="id" value="<?php echo $id;?>" />
		</form>
<?php
	}
	static function ShowCertificate( $course_id, $option, &$row, &$lists ) {
		global $Itemid;
		echo new \LMS\Widgets\ContentHeader(array('title' => ($row->id ? _JLMS_QUIZ_EDIT_CRTF_BTN : _JLMS_QUIZ_NEW_CRTF_BTN), 'icon' => 'quizzes'));
		$contentToolbar = new \LMS\Widgets\ContentToolbar();
		$contentToolbar->addSaveButton(array('href' => "javascript:submitbutton('save_crtf');", 'title' => _JLMS_QUIZ_SAVE_CRTF_BTN));
		$contentToolbar->addApplyButton(array('href' => "javascript:submitbutton('apply_crtf');"));
		$contentToolbar->addPreviewButton(array('href' => "javascript:jlms_ShowCertificatePreview();", 'title' => _JLMS_QUIZ_PREVIEW_CRTF_BTN));
		$contentToolbar->addCancelButton(array('href' => "javascript:submitbutton('cancel_crtf');", 'title' => _JLMS_QUIZ_CANCEL_BTN));
		echo $contentToolbar->render();
		require_once(_JOOMLMS_FRONT_HOME . "/includes/lms_certificates.php");
		?>
<script language="javascript" type="text/javascript">
<!--
function submitbutton(pressbutton) {
	var proceed_to_submit = true;
	var form = document.adminForm;
	if (pressbutton == 'save_crtf' || pressbutton == 'apply_crtf') {
		if (form.crtf_name.value == '') {
			alert('<?php echo _JLMS_PL_ENTER_NAME;?>');
			proceed_to_submit = false;
		}
	}
	if (proceed_to_submit) {
		form.page.value = pressbutton;
		form.submit();
	}
}
//-->
</script>
		<form action="<?php echo sefRelToAbs("index.php?option=$option&Itemid=$Itemid");?>" method="post" name="adminForm" enctype="multipart/form-data">
		<table width="100%" cellpadding="0" cellspacing="0" border="0" class="jlms_table_no_borders">
			<tr>
				<td width="100%">
				<?php JLMS_Certificates::JLMS_editCertificate_Page( $row );?>
				</td>
			</tr>
		</table>
		<input type="hidden" name="option" value="<?php echo $option;?>" />
		<input type="hidden" name="page" value="" />
		<input type="hidden" name="task" value="quizzes" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="id" value="<?php echo $course_id;?>" />
		<input type="hidden" name="crtf_id" value="<?php echo $row->id;?>" />
		</form>
<?php
	}
}