<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * 
 */

namespace LMS\Tools\Conference\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

/**
 *
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * @since       3.1
 */
class Conference extends Base\View
{
	protected $item = null;

	/**
	 * @var    string  Default title to use for page title
	 * @since  3.2
	 */
	protected $defaultPageTitle = 'Conferences';

	/**
	 * @var    string  The name of the extension for the mailbox
	 * @since  3.2
	 */
	protected $extension = 'com_joomla_lms';

	/**
	 * @var    string  The name of the view to link individual items to
	 * @since  3.2
	 */
	protected $viewName = 'conference';

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	/**
	 * Execute and display a template script.
	 *
	 * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
	 *
	 * @return  mixed  A string if successful, otherwise a Error object.
	 */
	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

}
