<?php
namespace LMS\Tools\Homework\Helpers;

defined('_JEXEC') or die;

class OutputText
{
	public static function cutTextByNumberWords($text_description, $show_num_words = 100)
	{
		preg_match_all('#\S+#', $text_description, $out, PREG_PATTERN_ORDER);
		if(isset($out[0]) && is_array($out[0]) && count($out[0])){
			$all_words = $out[0];
			$num_words = count($all_words);
			if($num_words > $show_num_words){
				$text_description = implode(' ', array_slice($all_words, 0, $show_num_words));
				$text_description .= ' ..';
			}
		}
		return $text_description;
	}

	public static function addPropertiesForTooltip($text_description, $show_num_words = 100, $data_placement='top')
	{
		$property = '';
		if($text_description){
			$property = 'class="hasTooltip"';
			$text_description = static::cutTextByNumberWords($text_description, $show_num_words);
			$text_description = '<strong>'._JLMS_DESCRIPTION.':</strong> ' . $text_description;
			$property .= 'title="'.\JHtml::tooltipText($text_description).'"';
			$property .= 'data-placement="'.$data_placement.'"';
		}
		return $property;
	}
}

 