<?php
$cols = $this->cols;
$filters = $this->filters;
$type = $this->type;

if(!$this->ajax) { ?>
<div id="widget-table-<?php echo $type; ?>">
<?php echo $filters; ?>
<div class="content">
<?php } ?>
<table class="table table-hover">
<thead>	
	<tr>
<?php foreach($cols AS $key => $title) {?>
		<th>
		<?php echo $title?>
		</th>		
<?php };?>
	</tr>
</thead>
<?php 
$colsNum = count((array)$cols);
if(!empty($this->pagination)) {
?>
<tfoot>
<tr>
	<td colspan="<?php echo $colsNum ?>">
		<?php echo $this->pagination->getListFooter(); ?>
	</td>
</tr>
</tfoot>
<?php } ?>
<tbody>
<?php 
$data = $this->data;
foreach($this->items AS $item) {
	$dataHtml = '';
	for($i = 0; $i < 2; $i++) {
		if(!isset($data[$i])) {
			break;
		}
		
		$field = $data[$i];
		
		$value = (is_array($item->$field))?implode(',', $item->$field):$item->$field;
		
		$dataHtml .= 'data-'.(($i == 0)?'id':'ext-id').'="'.$value.'" ';
	}
?>
	<tr <?php echo $dataHtml ?> class="widget-table-row">
	<?php foreach($cols AS $key => $title) {?>
		<td>
		<?php echo $item->{$key}; ?>
		</td>		
	<?php };?>
	</tr>
<?php };?>
</tbody>
</table>
<?php if(!$this->ajax) { ?>
</div>
</div>
<?php } ?>